package com.misc;


import java.awt.*;
import javax.swing.*;
import com.jpe.Constants;
import com.jpe.jpe;
/*
 * JDialog.java
 *
 * Created on 29 April 2003, 11:23
 */

/**
 *
 * @author  MBeynon
 */
public class PrefsDialog extends JDialog implements Constants{

    /** Creates new form JDialog */
    public PrefsDialog(jpe win, boolean modal) {

         super( win );
         this.win = win;
       // super(win, modal);
        setModal( false );
        setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);

        java.awt.GridBagConstraints gridBagConstraints;

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jbtDelimeterColor = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jbtSelectionColor = new javax.swing.JButton();
        jLabel11 = new javax.swing.JLabel();
        jbtHighlightColor = new javax.swing.JButton();
        jLabel12 = new javax.swing.JLabel();
        jbtCaretColor1 = new javax.swing.JButton();
        jLabel13 = new javax.swing.JLabel();
        jPanel5 = new javax.swing.JPanel();
        jcheckInvalidLines = new javax.swing.JCheckBox();
        jcheckLockOpenFile = new javax.swing.JCheckBox();
        jcheckLineHighlight11 = new javax.swing.JCheckBox();
        jcheckBlockCaret1 = new javax.swing.JCheckBox();
        jcheckBlinkCaret1 = new javax.swing.JCheckBox();
        jcheckDelimeter1 = new javax.swing.JCheckBox();
        jcheckEOLMarkers1 = new javax.swing.JCheckBox();
        jPanel2 = new javax.swing.JPanel();
        jPanel41 = new javax.swing.JPanel();
        jbtGutterColor = new javax.swing.JButton();
        jLabel111 = new javax.swing.JLabel();
        jbtGutterFontColor = new javax.swing.JButton();
        jLabel121 = new javax.swing.JLabel();
        jbtGutterHighlightColor = new javax.swing.JButton();
        jLabel131 = new javax.swing.JLabel();
        jPanel51 = new javax.swing.JPanel();
        jcheckShowGutter = new javax.swing.JCheckBox();
        jbtGutterInterval = new javax.swing.JButton();
        jLabel1211 = new javax.swing.JLabel();
        jbtGutterWidth1 = new javax.swing.JButton();
        jLabel1311 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jPanel511 = new javax.swing.JPanel();
        jcheckAutoSave = new javax.swing.JCheckBox();
        jcheckFullPath1 = new javax.swing.JCheckBox();
        jcheckTabsOnBottom1 = new javax.swing.JCheckBox();
        jcheckOpenLastDoc1 = new javax.swing.JCheckBox();
        jcheckReadOnlyNotify1 = new javax.swing.JCheckBox();
        jcheckCheckFileMod = new javax.swing.JCheckBox();
        jPanel512 = new javax.swing.JPanel();
        jLabel12111 = new javax.swing.JLabel();
        jbtFont = new javax.swing.JButton();
        jLabel13111 = new javax.swing.JLabel();
        jbtTabs = new javax.swing.JButton();
        jbtRecentFiles1 = new javax.swing.JButton();
        jLabel131112 = new javax.swing.JLabel();
        jbtBookmarks = new javax.swing.JButton();
        jLabel131113 = new javax.swing.JLabel();
        jbtClipboards = new javax.swing.JButton();
        jLabel131114 = new javax.swing.JLabel();
        jbtStartTimer1 = new javax.swing.JButton();
        jLabel131115 = new javax.swing.JLabel();
        jbtUndos = new javax.swing.JButton();
        jLabel131116 = new javax.swing.JLabel();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setTitle("Preferences");
        setModal(true);
        setName("PrefsDialog");
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jTabbedPane1.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        jTabbedPane1.setToolTipText("");
        jTabbedPane1.setFont(SYSTEM_FONT);
        jPanel1.setLayout(new com.awtextra.AbsoluteLayout());

        jPanel4.setLayout(new com.awtextra.AbsoluteLayout());

        jPanel4.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        jbtDelimeterColor.setFont(SYSTEM_FONT);
        jbtDelimeterColor.setToolTipText("Sets the delimiter colour");
        jbtDelimeterColor.setPreferredSize(new java.awt.Dimension(20, 20));
        jbtDelimeterColor.setBackground(win.getBracketColor());
        jbtDelimeterColor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtDelimeterColorActionPerformed(evt);
            }
        });

        jPanel4.add(jbtDelimeterColor, new com.awtextra.AbsoluteConstraints(10, 100, -1, -1));

        jLabel1.setFont(SYSTEM_FONT);
        jLabel1.setText("Delimiter colour");
        jPanel4.add(jLabel1, new com.awtextra.AbsoluteConstraints(34, 100, 130, 20));

        jbtSelectionColor.setFont(SYSTEM_FONT);
        jbtSelectionColor.setToolTipText("Sets the editors selection colour");
        jbtSelectionColor.setPreferredSize(new java.awt.Dimension(20, 20));
        jbtSelectionColor.setBackground(win.getSelectionColor());
        jbtSelectionColor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtSelectionColorActionPerformed(evt);
            }
        });

        jPanel4.add(jbtSelectionColor, new com.awtextra.AbsoluteConstraints(10, 10, -1, -1));

        jLabel11.setFont(SYSTEM_FONT);
        jLabel11.setText("Selection colour");
        jPanel4.add(jLabel11, new com.awtextra.AbsoluteConstraints(34, 10, 130, 20));

        jbtHighlightColor.setFont(SYSTEM_FONT);
        jbtHighlightColor.setToolTipText("Sets the editors line highlight colour");
        jbtHighlightColor.setPreferredSize(new java.awt.Dimension(20, 20));
        jbtHighlightColor.setBackground(win.getLineHighLightColor());
        jbtHighlightColor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtHighlightColorActionPerformed(evt);
            }
        });

        jPanel4.add(jbtHighlightColor, new com.awtextra.AbsoluteConstraints(10, 40, -1, -1));

        jLabel12.setFont(SYSTEM_FONT);
        jLabel12.setText("Highlight colour");
        jLabel12.setToolTipText("");
        jPanel4.add(jLabel12, new com.awtextra.AbsoluteConstraints(34, 40, 130, 20));

        jbtCaretColor1.setFont(SYSTEM_FONT);
        jbtCaretColor1.setToolTipText("Sets the caret's colour");
        jbtCaretColor1.setPreferredSize(new java.awt.Dimension(20, 20));
        jbtCaretColor1.setBackground(win.getCaretColor());
        jbtCaretColor1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtCaretColor1ActionPerformed(evt);
            }
        });

        jPanel4.add(jbtCaretColor1, new com.awtextra.AbsoluteConstraints(10, 70, -1, -1));

        jLabel13.setFont(SYSTEM_FONT);
        jLabel13.setText("Caret colour");
        jLabel13.setToolTipText("");
        jPanel4.add(jLabel13, new com.awtextra.AbsoluteConstraints(34, 70, 130, 20));

        jPanel1.add(jPanel4, new com.awtextra.AbsoluteConstraints(10, 15, 180, 250));

        jPanel5.setLayout(new com.awtextra.AbsoluteLayout());

        jPanel5.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        jcheckInvalidLines.setFont(SYSTEM_FONT);
        jcheckInvalidLines.setText("Invalid lines");
        jcheckInvalidLines.setSelected(win.getInvalidLines());
        jcheckInvalidLines.setToolTipText("Enables/disables the invalid line markers");
        jcheckInvalidLines.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jcheckInvalidLinesItemStateChanged(evt);
            }
        });

        jPanel5.add(jcheckInvalidLines, new com.awtextra.AbsoluteConstraints(10, 160, 120, -1));

        jcheckLineHighlight11.setFont(SYSTEM_FONT);
        jcheckLineHighlight11.setText("Line Highlight");
        jcheckLineHighlight11.setSelected(win.getLineHighlight());
        jcheckLineHighlight11.setToolTipText("Enables/disables line highlighting");
        jcheckLineHighlight11.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jcheckLineHighlight11ItemStateChanged(evt);
            }
        });

        jPanel5.add(jcheckLineHighlight11, new com.awtextra.AbsoluteConstraints(10, 10, 120, -1));

        jcheckBlockCaret1.setFont(SYSTEM_FONT);
        jcheckBlockCaret1.setText("Block caret");
        jcheckBlockCaret1.setSelected(win.getBlockCaret());
        jcheckBlockCaret1.setToolTipText("Enables/disables the block caret");
        jcheckBlockCaret1.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jcheckBlockCaret1ItemStateChanged(evt);
            }
        });

        jPanel5.add(jcheckBlockCaret1, new com.awtextra.AbsoluteConstraints(10, 40, 120, -1));

        jcheckBlinkCaret1.setFont(SYSTEM_FONT);
        jcheckBlinkCaret1.setText("Blink caret");
        jcheckBlinkCaret1.setSelected(win.getCaretBlink());
        jcheckBlinkCaret1.setToolTipText("Enables/disables caret blinking");
        jcheckBlinkCaret1.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jcheckBlinkCaret1ItemStateChanged(evt);
            }
        });

        jPanel5.add(jcheckBlinkCaret1, new com.awtextra.AbsoluteConstraints(10, 70, 120, -1));

        jcheckDelimeter1.setFont(SYSTEM_FONT);
        jcheckDelimeter1.setText("Delimiter check");
        jcheckDelimeter1.setSelected(win.getBracketHighlight());
        jcheckDelimeter1.setToolTipText("Enables/disables the delimiter check");
        jcheckDelimeter1.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jcheckDelimeter1ItemStateChanged(evt);
            }
        });

        jPanel5.add(jcheckDelimeter1, new com.awtextra.AbsoluteConstraints(10, 100, 120, -1));

        jcheckEOLMarkers1.setFont(SYSTEM_FONT);
        jcheckEOLMarkers1.setText("EOL Mmarkers");
        jcheckEOLMarkers1.setSelected(win.getEOLMarkers());
        jcheckEOLMarkers1.setToolTipText("Enables/disables the end of line markers");
        jcheckEOLMarkers1.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jcheckEOLMarkers1ItemStateChanged(evt);
            }
        });

        jPanel5.add(jcheckEOLMarkers1, new com.awtextra.AbsoluteConstraints(10, 130, 120, -1));

        jPanel1.add(jPanel5, new com.awtextra.AbsoluteConstraints(205, 15, 180, 250));

        jTabbedPane1.addTab("Editor", jPanel1);

        jPanel2.setLayout(new com.awtextra.AbsoluteLayout());

        jPanel41.setLayout(new com.awtextra.AbsoluteLayout());

        jPanel41.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        jbtGutterColor.setFont(SYSTEM_FONT);
        jbtGutterColor.setToolTipText("Sets the gutter's colour");
        jbtGutterColor.setPreferredSize(new java.awt.Dimension(20, 20));
        jbtGutterColor.setBackground(win.getGutterBak());
        jbtGutterColor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtGutterColorActionPerformed(evt);
            }
        });

        jPanel41.add(jbtGutterColor, new com.awtextra.AbsoluteConstraints(10, 10, -1, -1));

        jLabel111.setFont(SYSTEM_FONT);
        jLabel111.setText("Gutter colour");
        jPanel41.add(jLabel111, new com.awtextra.AbsoluteConstraints(34, 10, 130, 20));

        jbtGutterFontColor.setFont(SYSTEM_FONT);
        jbtGutterFontColor.setToolTipText("Sets the gutter's font colour");
        jbtGutterFontColor.setPreferredSize(new java.awt.Dimension(20, 20));
        jbtGutterFontColor.setBackground(win.getGutterFor());
        jbtGutterFontColor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtGutterFontColorActionPerformed(evt);
            }
        });

        jPanel41.add(jbtGutterFontColor, new com.awtextra.AbsoluteConstraints(10, 40, -1, -1));

        jLabel121.setFont(SYSTEM_FONT);
        jLabel121.setText("Font colour");
        jPanel41.add(jLabel121, new com.awtextra.AbsoluteConstraints(34, 40, 130, 20));

        jbtGutterHighlightColor.setFont(SYSTEM_FONT);
        jbtGutterHighlightColor.setToolTipText("Sets the gutter's highlight colour ");
        jbtGutterHighlightColor.setPreferredSize(new java.awt.Dimension(20, 20));
        jbtGutterHighlightColor.setBackground(win.getGutterHigh());
        jbtGutterHighlightColor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtGutterHighlightColorActionPerformed(evt);
            }
        });

        jPanel41.add(jbtGutterHighlightColor, new com.awtextra.AbsoluteConstraints(10, 70, -1, -1));

        jLabel131.setFont(SYSTEM_FONT);
        jLabel131.setText("Highlight colour");
        jPanel41.add(jLabel131, new com.awtextra.AbsoluteConstraints(34, 70, 130, 20));

        jPanel2.add(jPanel41, new com.awtextra.AbsoluteConstraints(10, 15, 180, 250));

        jPanel51.setLayout(new com.awtextra.AbsoluteLayout());

        jPanel51.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        jcheckShowGutter.setFont(SYSTEM_FONT);
        jcheckShowGutter.setText("Show gutter");
        jcheckShowGutter.setSelected(win.getGutter());
        jcheckShowGutter.setToolTipText("Enables/disables the gutter");
        jcheckShowGutter.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jcheckShowGutterItemStateChanged(evt);
            }
        });

        jPanel51.add(jcheckShowGutter, new com.awtextra.AbsoluteConstraints(10, 10, 120, -1));

        jbtGutterInterval.setToolTipText("Sets the gutter's highlight interval - Currently " + win.getGutterInterval());
        jbtGutterInterval.setPreferredSize(new java.awt.Dimension(13, 13));
        jbtGutterInterval.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtGutterIntervalActionPerformed(evt);
            }
        });

        jPanel51.add(jbtGutterInterval, new com.awtextra.AbsoluteConstraints(10, 74, -1, -1));

        jLabel1211.setFont(SYSTEM_FONT);
        jLabel1211.setText("Gutter Width");
        jPanel51.add(jLabel1211, new com.awtextra.AbsoluteConstraints(28, 40, 130, 20));

        jbtGutterWidth1.setToolTipText("Sets the gutter's width - Currently " + win.getGutterWidth());
        jbtGutterWidth1.setPreferredSize(new java.awt.Dimension(13, 13));
        jbtGutterWidth1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtGutterWidth1ActionPerformed(evt);
            }
        });

        jPanel51.add(jbtGutterWidth1, new com.awtextra.AbsoluteConstraints(10, 44, -1, -1));

        jLabel1311.setFont(SYSTEM_FONT);
        jLabel1311.setText("Gutter Interval");
        jPanel51.add(jLabel1311, new com.awtextra.AbsoluteConstraints(28, 70, 130, 20));

        jPanel2.add(jPanel51, new com.awtextra.AbsoluteConstraints(205, 15, 180, 250));

        jTabbedPane1.addTab("Gutter", jPanel2);

        jPanel3.setLayout(new com.awtextra.AbsoluteLayout());

        jPanel511.setLayout(new com.awtextra.AbsoluteLayout());

        jPanel511.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        jcheckAutoSave.setFont(SYSTEM_FONT);
        jcheckAutoSave.setText("Start/Stop auto save");
        jcheckAutoSave.setSelected(win.getAutoSave());
        jcheckAutoSave.setToolTipText("Starts or stops the autosave function");
        jcheckAutoSave.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jcheckAutoSaveItemStateChanged(evt);
            }
        });

        jPanel511.add(jcheckAutoSave, new com.awtextra.AbsoluteConstraints(10, 130, 120, -1));


        jcheckCheckFileMod.setFont(SYSTEM_FONT);
				jcheckCheckFileMod.setText("Check for file mods");
				jcheckCheckFileMod.setSelected(win.getCheckFileMod());
				jcheckCheckFileMod.setToolTipText("Checks for document modifications outside the application");
				jcheckCheckFileMod.addItemListener(new java.awt.event.ItemListener() {
						public void itemStateChanged(java.awt.event.ItemEvent evt) {
								jcheckCheckFileModItemStateChanged(evt);
						}
				});

        jPanel511.add(jcheckCheckFileMod, new com.awtextra.AbsoluteConstraints(10, 160, 120, -1));


        /*jcheckLockOpenFile.setFont(SYSTEM_FONT);
				jcheckLockOpenFile.setText("Lock open files");
				jcheckLockOpenFile.setSelected(win.getLockFile());
				jcheckLockOpenFile.setToolTipText("Lock open files for editing");
				jcheckLockOpenFile.addItemListener(new java.awt.event.ItemListener() {
						public void itemStateChanged(java.awt.event.ItemEvent evt) {
								jcheckLockOpenFileItemStateChanged(evt);
						}
				});

        jPanel511.add(jcheckLockOpenFile, new com.awtextra.AbsoluteConstraints(10, 190, 120, -1));*/



        jcheckFullPath1.setFont(SYSTEM_FONT);
        jcheckFullPath1.setText("Full path in Tabs");
        jcheckFullPath1.setSelected(win.getFullPathInTabs());
        jcheckFullPath1.setToolTipText("Displays the full file path in the tab");
        jcheckFullPath1.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jcheckFullPath1ItemStateChanged(evt);
            }
        });

        jPanel511.add(jcheckFullPath1, new com.awtextra.AbsoluteConstraints(10, 10, 120, -1));

        jcheckTabsOnBottom1.setFont(SYSTEM_FONT);
        jcheckTabsOnBottom1.setText("Tabs on bottom");
        jcheckTabsOnBottom1.setSelected(win.getTabsOnBottom());
        jcheckTabsOnBottom1.setToolTipText("Places the tabs at the bottom of the document");
        jcheckTabsOnBottom1.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jcheckTabsOnBottom1ItemStateChanged(evt);
            }
        });

        jPanel511.add(jcheckTabsOnBottom1, new com.awtextra.AbsoluteConstraints(10, 40, 120, -1));

        jcheckOpenLastDoc1.setFont(SYSTEM_FONT);
        jcheckOpenLastDoc1.setText("Open last document");
        jcheckOpenLastDoc1.setSelected(win.getLastDoc());
        jcheckOpenLastDoc1.setToolTipText("Opens the last document edited at start up");
        jcheckOpenLastDoc1.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jcheckOpenLastDoc1ItemStateChanged(evt);
            }
        });

        jPanel511.add(jcheckOpenLastDoc1, new com.awtextra.AbsoluteConstraints(10, 70, 120, -1));

        jcheckReadOnlyNotify1.setFont(SYSTEM_FONT);
        jcheckReadOnlyNotify1.setText("Read only notify");
        jcheckReadOnlyNotify1.setSelected(win.getReadOnlyNotify());
        jcheckReadOnlyNotify1.setToolTipText("Notifys if a file is read only");
        jcheckReadOnlyNotify1.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jcheckReadOnlyNotify1ItemStateChanged(evt);
            }
        });

        jPanel511.add(jcheckReadOnlyNotify1, new com.awtextra.AbsoluteConstraints(10, 100, 120, -1));

        jPanel3.add(jPanel511, new com.awtextra.AbsoluteConstraints(10, 15, 180, 250));

        jPanel512.setLayout(new com.awtextra.AbsoluteLayout());

        jPanel512.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        jLabel12111.setFont(SYSTEM_FONT);
        jLabel12111.setText("Editor Font");
        jLabel12111.setToolTipText(" Sets the editor's font");
        jPanel512.add(jLabel12111, new com.awtextra.AbsoluteConstraints(28, 10, 130, 20));

        jbtFont.setPreferredSize(new java.awt.Dimension(13, 13));
        jbtFont.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtFontActionPerformed(evt);
            }
        });

        jPanel512.add(jbtFont, new com.awtextra.AbsoluteConstraints(10, 15, -1, -1));

        jLabel13111.setFont(SYSTEM_FONT);
        jLabel13111.setText("Tab size");
        jLabel13111.setToolTipText("Sets the editor's tab size - Currently " + win.getTabSize());
        jPanel512.add(jLabel13111, new com.awtextra.AbsoluteConstraints(28, 190, 130, 20));

        jbtTabs.setPreferredSize(new java.awt.Dimension(13, 13));
        jbtTabs.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtTabsActionPerformed(evt);
            }
        });

        jPanel512.add(jbtTabs, new com.awtextra.AbsoluteConstraints(10, 194, -1, -1));

        jbtRecentFiles1.setPreferredSize(new java.awt.Dimension(13, 13));
        jbtRecentFiles1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtRecentFiles1ActionPerformed(evt);
            }
        });

        jPanel512.add(jbtRecentFiles1, new com.awtextra.AbsoluteConstraints(10, 44, -1, -1));

        jLabel131112.setFont(SYSTEM_FONT);
        jLabel131112.setText("Recent Files");
        jLabel131112.setToolTipText("The number of files in the recent documents list - Currently " + win.getNumRecents());
        jPanel512.add(jLabel131112, new com.awtextra.AbsoluteConstraints(28, 40, 130, 20));

        jbtBookmarks.setPreferredSize(new java.awt.Dimension(13, 13));
        jbtBookmarks.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtBookmarksActionPerformed(evt);
            }
        });

        jPanel512.add(jbtBookmarks, new com.awtextra.AbsoluteConstraints(10, 74, -1, -1));

        jLabel131113.setFont(SYSTEM_FONT);
        jLabel131113.setText("Number of Bookmarks");
        jLabel131113.setToolTipText("The number of bookmark buttons on the toolbar - Currently " + win.getNumberOfBookMarks());
        jPanel512.add(jLabel131113, new com.awtextra.AbsoluteConstraints(28, 70, 130, 20));

        jbtClipboards.setPreferredSize(new java.awt.Dimension(13, 13));
        jbtClipboards.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtClipboardsActionPerformed(evt);
            }
        });

        jPanel512.add(jbtClipboards, new com.awtextra.AbsoluteConstraints(10, 104, -1, -1));

        jLabel131114.setFont(SYSTEM_FONT);
        jLabel131114.setText("Number of Clipboards");
        jLabel131114.setToolTipText("The number of clipboard buttons on the toolbar - Currently " + win.getNumberOfClipBoards());
        jPanel512.add(jLabel131114, new com.awtextra.AbsoluteConstraints(28, 100, 130, 20));

        jbtStartTimer1.setPreferredSize(new java.awt.Dimension(13, 13));
        jbtStartTimer1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtStartTimer1ActionPerformed(evt);
            }
        });

        jPanel512.add(jbtStartTimer1, new com.awtextra.AbsoluteConstraints(10, 134, -1, -1));

        jLabel131115.setFont(SYSTEM_FONT);
        jLabel131115.setText("Save timer interval");
        jLabel131115.setToolTipText("Sets the auto save timer interval - Currently " + win.getTimer());
        jPanel512.add(jLabel131115, new com.awtextra.AbsoluteConstraints(28, 130, 130, 20));

        jbtUndos.setPreferredSize(new java.awt.Dimension(13, 13));
        jbtUndos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtUndosActionPerformed(evt);
            }
        });

        jPanel512.add(jbtUndos, new com.awtextra.AbsoluteConstraints(10, 164, -1, -1));

        jLabel131116.setFont(SYSTEM_FONT);
        jLabel131116.setText("Number of undo's");
        jLabel131116.setToolTipText("Sets the number of undo's - Currently " + win.getUndoLimit());
        jPanel512.add(jLabel131116, new com.awtextra.AbsoluteConstraints(28, 160, 130, 20));

        jPanel3.add(jPanel512, new com.awtextra.AbsoluteConstraints(205, 15, 180, 250));

        jTabbedPane1.addTab("Misc", jPanel3);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 10;
        gridBagConstraints.ipady = 13;
        getContentPane().add(jTabbedPane1, gridBagConstraints);

        pack();
    }//GEN-END:initComponents

    //tab size button!
    private void jbtTabsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtTabsActionPerformed
        win.setTabSize();
        jLabel13111.setToolTipText("Sets the editor's tab size - Currently " + win.getTabSize());
    }//GEN-LAST:event_jbtTabsActionPerformed

    private void jbtUndosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtUndosActionPerformed
        win.setUndoLimit();
        jLabel131116.setToolTipText("Sets the number of undo's - Currently " + win.getUndoLimit());
    }//GEN-LAST:event_jbtUndosActionPerformed

    private void jbtStartTimer1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtStartTimer1ActionPerformed
        win.setTimer();
        jLabel131115.setToolTipText("Sets the auto save timer interval - Currently " + win.getTimer());
    }//GEN-LAST:event_jbtStartTimer1ActionPerformed

    private void jbtClipboardsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtClipboardsActionPerformed
        win.setNumberOfClipBoards();
        jLabel131114.setToolTipText("The number of clipboard buttons on the toolbar - Currently " + win.getNumberOfClipBoards());
    }//GEN-LAST:event_jbtClipboardsActionPerformed

    private void jbtBookmarksActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtBookmarksActionPerformed
        win.setNumberOfBookMarks();
        jLabel131113.setToolTipText("The number of bookmark buttons on the toolbar - Currently " + win.getNumberOfBookMarks());
    }//GEN-LAST:event_jbtBookmarksActionPerformed

    private void jbtRecentFiles1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtRecentFiles1ActionPerformed
        win.setNumberOfRecents();
        jLabel131112.setToolTipText("The number of files in the recent documents list - Currently " + win.getNumRecents());
    }//GEN-LAST:event_jbtRecentFiles1ActionPerformed

    private void jbtFontActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtFontActionPerformed
        win.FontChooser();
    }//GEN-LAST:event_jbtFontActionPerformed

    private void jcheckAutoSaveItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jcheckAutoSaveItemStateChanged
        win.selectAutoSave();
    }//GEN-LAST:event_jcheckAutoSaveItemStateChanged

    private void jcheckReadOnlyNotify1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jcheckReadOnlyNotify1ItemStateChanged
        win.selectReadOnlyNotify();
    }//GEN-LAST:event_jcheckReadOnlyNotify1ItemStateChanged

    private void jcheckOpenLastDoc1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jcheckOpenLastDoc1ItemStateChanged
        win.selectLastDoc();
    }//GEN-LAST:event_jcheckOpenLastDoc1ItemStateChanged

    private void jcheckTabsOnBottom1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jcheckTabsOnBottom1ItemStateChanged
        win.selectTabsOnBottom();
    }//GEN-LAST:event_jcheckTabsOnBottom1ItemStateChanged

    private void jcheckFullPath1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jcheckFullPath1ItemStateChanged
        win.selectFullPathInTabs();
    }//GEN-LAST:event_jcheckFullPath1ItemStateChanged

    private void jcheckCheckFileModItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jcheckCheckFileModItemStateChanged
		        win.selectCheckFileMod();
    }//GEN-LAST:event_jcheckCheckFileModItemStateChanged

    private void jbtGutterIntervalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtGutterIntervalActionPerformed
        win.setGutterInterval();
        jbtGutterInterval.setToolTipText("Sets the gutter's highlight interval - Currently " + win.getGutterInterval());
    }//GEN-LAST:event_jbtGutterIntervalActionPerformed

    private void jbtGutterWidth1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtGutterWidth1ActionPerformed
         win.setGutterWidth();
         jbtGutterWidth1.setToolTipText("Sets the gutter's width - Currently " + win.getGutterWidth());
    }//GEN-LAST:event_jbtGutterWidth1ActionPerformed




    private void jcheckLockOpenFileItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jcheckLockOpenFileItemStateChanged
		        win.selectFileLock(jcheckLockOpenFile.isSelected());
    }//GEN-LAST:event_jcheckLockOpenFileItemStateChanged



    private void jcheckShowGutterItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jcheckShowGutterItemStateChanged
        win.selectGutter();
    }//GEN-LAST:event_jcheckShowGutterItemStateChanged

    private void jbtGutterHighlightColorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtGutterHighlightColorActionPerformed
        win.setGutterHigh();
        jbtGutterHighlightColor.setBackground(win.getGutterHigh());
    }//GEN-LAST:event_jbtGutterHighlightColorActionPerformed

    private void jbtGutterFontColorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtGutterFontColorActionPerformed
        win.setGutterFor();
        jbtGutterFontColor.setBackground(win.getGutterFor());
    }//GEN-LAST:event_jbtGutterFontColorActionPerformed

    private void jbtGutterColorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtGutterColorActionPerformed
        win.setGutterBak();
        jbtGutterColor.setBackground(win.getGutterBak());
    }//GEN-LAST:event_jbtGutterColorActionPerformed

    private void jcheckInvalidLinesItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jcheckInvalidLinesItemStateChanged
        win.selectInvalidLines();
    }//GEN-LAST:event_jcheckInvalidLinesItemStateChanged

    private void jcheckEOLMarkers1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jcheckEOLMarkers1ItemStateChanged
        win.selectEOLMarkers();
    }//GEN-LAST:event_jcheckEOLMarkers1ItemStateChanged

    private void jcheckDelimeter1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jcheckDelimeter1ItemStateChanged
        win.selectBracketHighlight();
    }//GEN-LAST:event_jcheckDelimeter1ItemStateChanged

    private void jcheckBlinkCaret1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jcheckBlinkCaret1ItemStateChanged
        win.selectCaretBlink();
    }//GEN-LAST:event_jcheckBlinkCaret1ItemStateChanged

    private void jcheckBlockCaret1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jcheckBlockCaret1ItemStateChanged
        win.selectBlockCaret();
    }//GEN-LAST:event_jcheckBlockCaret1ItemStateChanged

    private void jcheckLineHighlight11ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jcheckLineHighlight11ItemStateChanged
        win.selectLineHighlight();
    }//GEN-LAST:event_jcheckLineHighlight11ItemStateChanged

    private void jbtDelimeterColorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtDelimeterColorActionPerformed
        win.setBracketColor();
        jbtDelimeterColor.setBackground(win.getBracketColor());
    }//GEN-LAST:event_jbtDelimeterColorActionPerformed

    private void jbtCaretColor1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtCaretColor1ActionPerformed
        win.setCaretColor();
        jbtCaretColor1.setBackground(win.getCaretColor());
    }//GEN-LAST:event_jbtCaretColor1ActionPerformed

    private void jbtHighlightColorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtHighlightColorActionPerformed
        win.setLineHighlightColor();
        jbtHighlightColor.setBackground(win.getLineHighLightColor());
    }//GEN-LAST:event_jbtHighlightColorActionPerformed

    private void jbtSelectionColorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtSelectionColorActionPerformed
        win.setSelectionColor();
        jbtSelectionColor.setBackground(win.getSelectionColor());
    }//GEN-LAST:event_jbtSelectionColorActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog



    // Variables declaration - do not modify//GEN-BEGIN:variables
    private jpe win;
    private javax.swing.JButton jbtHighlightColor;
    private javax.swing.JButton jbtGutterFontColor;
    private javax.swing.JButton jbtSelectionColor;
    private javax.swing.JLabel jLabel131116;
    private javax.swing.JButton jbtBookmarks;
    private javax.swing.JCheckBox jcheckReadOnlyNotify1;
    private javax.swing.JLabel jLabel131;
    private javax.swing.JButton jbtClipboards;
    private javax.swing.JCheckBox jcheckOpenLastDoc1;
    private javax.swing.JPanel jPanel41;
    private javax.swing.JPanel jPanel511;
    private javax.swing.JLabel jLabel111;
    private javax.swing.JLabel jLabel131114;
    private javax.swing.JCheckBox jcheckLineHighlight11;
    private javax.swing.JButton jbtRecentFiles1;
    private javax.swing.JCheckBox jcheckEOLMarkers1;
    private javax.swing.JButton jbtCaretColor1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel51;
    private javax.swing.JLabel jLabel12111;
    private javax.swing.JCheckBox jcheckInvalidLines;
    private javax.swing.JLabel jLabel131115;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JButton jbtStartTimer1;
    private javax.swing.JLabel jLabel13111;
    private javax.swing.JButton jbtTabs;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel1211;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JButton jbtFont;
    private javax.swing.JButton jbtGutterWidth1;
    private javax.swing.JButton jbtGutterColor;
    private javax.swing.JCheckBox jcheckAutoSave;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JButton jbtGutterInterval;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JButton jbtUndos;
    private javax.swing.JPanel jPanel512;
    private javax.swing.JButton jbtDelimeterColor;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JCheckBox jcheckDelimeter1;
    private javax.swing.JCheckBox jcheckShowGutter;
    private javax.swing.JCheckBox jcheckLockOpenFile;
    private javax.swing.JButton jbtGutterHighlightColor;
    private javax.swing.JCheckBox jcheckFullPath1;
    private javax.swing.JCheckBox jcheckTabsOnBottom1;
    private javax.swing.JCheckBox jcheckCheckFileMod;
    private javax.swing.JLabel jLabel131113;
    private javax.swing.JCheckBox jcheckBlockCaret1;
    private javax.swing.JCheckBox jcheckBlinkCaret1;
    private javax.swing.JLabel jLabel131112;
    private javax.swing.JLabel jLabel121;
    private javax.swing.JLabel jLabel1311;
    // End of variables declaration//GEN-END:variables

}
