CDECK  ID>, HWHSS2.
*CMZ :-        -10/10/01  10:38:15  by  Peter Richardson
*-- Author :    Kosuke Odagiri
C-----------------------------------------------------------------------
      FUNCTION HWHSS2(S, T, U, M3, M4, SGN, CLL, CLR, CRL, CRR)
C-----------------------------------------------------------------------
C     LL(BAR) -> GAUGINOS (including beam polarization)
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE PRECISION HWHSS2, S, T, U, M3, M4, SGN
      DOUBLE COMPLEX CLL, CLR, CRL, CRR
      HWHSS2 =
C--first the incoming left electron
     & (ONE-EPOLN(3))*(ONE+PPOLN(3))*DREAL(
     & DCONJG(CLL)*CLL*(U-M3*M3)*(U-M4*M4)+
     & DCONJG(CLR)*CLR*(T-M3*M3)*(T-M4*M4)+
     & DCONJG(CLL)*CLR*2.*SGN*M3*M4*S )
C--then the incoming right electron
     &+(ONE+EPOLN(3))*(ONE-PPOLN(3))*DREAL(
     & DCONJG(CRR)*CRR*(U-M3*M3)*(U-M4*M4)+
     & DCONJG(CRL)*CRL*(T-M3*M3)*(T-M4*M4)+
     & DCONJG(CRL)*CRR*2.*SGN*M3*M4*S )
      RETURN
      END
