C
C
      SUBROUTINE FCCN(N,GRAD,CHI2,X,IFLAG,FUTIL)
C*********************************************************************
C
C     calculate chi**2 function ( called by MINUIT )
C
C     input parameter: GRAD   optional gradient vector, not used
C                      N      dimension of argument vector
C                      X      field of argument values
C                      CHI2   function value
C                      IFLAG  flag to indicate status of call
C                             ( see CERNLIB D507 )
C
C     output parameter:
C                      CHI2   function value: chi**2
C
C********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
      DIMENSION GRAD(*),X(*)
      EXTERNAL FUTIL
C
      PARAMETER (NECM=200,NPAR=30)
      PARAMETER (ZERO=0.D0,
     &           IZERO=0,
     &           IONE =1,
     &           ITWO =2,
     &          ITHREE=3,
     &           IFOUR=4)
      CHARACTER*6 HINT
      COMMON /FITMOD/ IFMOD,IFHARD
      COMMON /FITTYP/IFIT,NIST,ECMS(NECM),XTOT(NECM),XTOTE(NECM),
     &               XELA(NECM),XELAE(NECM),XINE(NECM),
     &               XINEE(NECM),XSDI(NECM),XSDIE(NECM),
     &               SLO(NECM),SLOE(NECM),XPRO(3,NECM),XPROE(3,NECM),
     &               XI(NPAR),XINC(NPAR),NFITP,HINT(NPAR),IFITF(NPAR)
C
      DIMENSION F(1000)
C
      CALL FUTIL(IFIT,N,F,X,IFLAG)
C
      CHI2 = 0.D0
      DO 100 I=1,IFIT
        CHI2 = CHI2 + F(I)**2
 100  CONTINUE
C
      END
