C
C
      SUBROUTINE PRIBLO(IMODE)
C**********************************************************************
C
C     input:  IMODE     0  output for BLOCK DATA construction
C                       1  read file bblo.txt
C                          (overwrite BLOCK DATA statements)
C                       2  write file bblo.txt from current settings
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      CHARACTER*8 ANAME,ZKNAM
      COMMON /POPART/ANAME(187),AM(187),GA(187),TAU(187),ICH(187),
     &               IBAR(187),K1(187),K2(187)
      COMMON /DECAYC/ZKNAM(550),NZK(550,3),WT(550)
**sr 29.04. commented to use dp-JETSET
      REAL  PMAS,PARF,VCKM
**
      COMMON/LUDAT2/KCHG(500,3),PMAS(500,4),PARF(2000),VCKM(4,4)
C  LUND function
*     REAL ULMASS
*     CHARACTER*16 PDGNAM
C
C  read file bblo.txt
      IF(IMODE.EQ.1) THEN
        OPEN(3,STATUS='OLD',FILE='bblo.txt')
        DO 1 I=1,187
          READ(3,2)
     &      ANAME(I),AM(I),GA(I),TAU(I),ICH(I),IBAR(I),K1(I),K2(I)
    2     FORMAT (A8,3E15.7,4I6)
C
*         IPDG=MPDGHA(I)
*         LUKF=IPD2LU(IPDG)
*         LUKF=IPDG
*         IJET=LUCOMP(LUKF)
*         PDGNAM=' '
*         AML1 = 0.D0
*         AML2 = 0.D0
*         IF((IPDG.NE.99999).AND.(IPDG.NE.0)) THEN
*           CALL LUNAME(LUKF,PDGNAM)
*           IF(IJET.NE.0) THEN
*             AML1 =INT(1000*ULMASS(LUKF))/1000.
*             AML2 = PMAS(IJET,1)
*             AM(I) = AML2
*           ENDIF
*         ENDIF
*         WRITE(6,'(2X,I3,3X,I6,2X,A8,E10.4,2X,A16,2X,2E11.4)')
*    &      I,IPDG,ANAME(I),AM(I),PDGNAM,AML1,AML2
*         WRITE(6,2)
*    &      ANAME(I),AM(I),GA(I),TAU(I),ICH(I),IBAR(I),K1(I),K2(I)
C
    1   CONTINUE
        DO 3 I=1,550
          READ(3,4) ZKNAM(I),NZK(I,1),NZK(I,2),NZK(I,3),WT(I)
    4     FORMAT (A8,3I6,F15.8)
    3   CONTINUE
        CLOSE(3)
C
C  write file bblo.txt to read decay channels
      ELSE IF(IMODE.EQ.2) THEN
        OPEN(3,STATUS='UNKNOWN',FILE='bblo.txt')
        DO 10 I=1,187
          WRITE(3,2)
     &      ANAME(I),AM(I),GA(I),TAU(I),ICH(I),IBAR(I),K1(I),K2(I)
 10     CONTINUE
        DO 11 I=1,550
          WRITE(3,4) ZKNAM(I),NZK(I,1),NZK(I,2),NZK(I,3),WT(I)
 11     CONTINUE
        CLOSE(3)
C
C  write DATA statements
      ELSE IF(IMODE.EQ.0) THEN
        NMAX=185
        NSTEP=5
        NIST=187
        IK=18
        K0=1
        DO 100 II=1,NMAX,NSTEP
          IF(IK.EQ.18) THEN
            IF(II.NE.1) WRITE(6,'(5X,A)') '&           /'
            WRITE(6,'(5X,A,I3,A,I3,A)') ' DATA (BNAME(K),K=',K0,',',
     &        MIN(NIST,K0-1+17*NSTEP),') /'
            K0=K0+17*NSTEP
            IK=1
          ENDIF
          WRITE(6,'(5X,16A)') '&  ',
     &      ('''',ANAME(I),''',',I=II,II+NSTEP-1)
          IK=IK+1
 100    CONTINUE
        WRITE(6,'(5X,16A)') '&  ',
     &    ('''',ANAME(I),''',',I=NMAX+1,NIST)
        WRITE(6,'(5X,A)') '&           /'
C
        NMAX=185
        NSTEP=5
        NIST=187
        IK=18
        K0=1
        DO 150 II=1,NMAX,NSTEP
          IF(IK.EQ.18) THEN
            IF(II.NE.1) WRITE(6,'(5X,A)') '&           /'
            WRITE(6,'(5X,A,I3,A,I3,A)') ' DATA (BM(K),K=',K0,',',
     &        MIN(NIST,K0-1+17*NSTEP),') /'
            K0=K0+17*NSTEP
            IK=1
          ENDIF
          WRITE(6,'(5X,A,10(E10.4,A))') '&  ',
     &      (AM(I),',',I=II,II+NSTEP-1)
          IK=IK+1
 150    CONTINUE
        WRITE(6,'(5X,A,10(E10.4,A))') '&  ',
     &    (AM(I),',',I=NMAX+1,NIST)
        WRITE(6,'(5X,A)') '&           /'
C
        NMAX=185
        NSTEP=5
        NIST=187
        IK=18
        K0=1
        DO 200 II=1,NMAX,NSTEP
          IF(IK.EQ.18) THEN
            IF(II.NE.1) WRITE(6,'(5X,A)') '&           /'
            WRITE(6,'(5X,A,I3,A,I3,A)') ' DATA (BA(K),K=',K0,',',
     &        MIN(NIST,K0-1+17*NSTEP),') /'
            K0=K0+17*NSTEP
            IK=1
          ENDIF
          WRITE(6,'(5X,A,10(E10.4,A))') '&  ',
     &      (GA(I),',',I=II,II+NSTEP-1)
          IK=IK+1
 200    CONTINUE
        WRITE(6,'(5X,A,10(E10.4,A))') '&  ',
     &    (GA(I),',',I=NMAX+1,NIST)
        WRITE(6,'(5X,A)') '&           /'
C
        NMAX=185
        NSTEP=5
        NIST=187
        IK=18
        K0=1
        DO 250 II=1,NMAX,NSTEP
          IF(IK.EQ.18) THEN
            IF(II.NE.1) WRITE(6,'(5X,A)') '&           /'
            WRITE(6,'(5X,A,I3,A,I3,A)') ' DATA (BAU(K),K=',K0,',',
     &        MIN(NIST,K0-1+17*NSTEP),') /'
            K0=K0+17*NSTEP
            IK=1
          ENDIF
          WRITE(6,'(5X,A,10(E10.4,A))') '&  ',
     &      (TAU(I),',',I=II,II+NSTEP-1)
          IK=IK+1
 250    CONTINUE
        WRITE(6,'(5X,A,10(E10.4,A))') '&  ',
     &    (TAU(I),',',I=NMAX+1,NIST)
        WRITE(6,'(5X,A)') '&           /'
C
        NMAX=180
        NSTEP=10
        NIST=187
        IK=18
        K0=1
        DO 300 II=1,NMAX,NSTEP
          IF(IK.EQ.18) THEN
            IF(II.NE.1) WRITE(6,'(5X,A)') '&           /'
            WRITE(6,'(5X,A,I3,A,I3,A)') ' DATA (IBCH(K),K=',K0,',',
     &        MIN(NIST,K0-1+17*NSTEP),') /'
            K0=K0+17*NSTEP
            IK=1
          ENDIF
          WRITE(6,'(5X,A,10(I3,A))') '&  ',
     &      (ICH(I),',',I=II,II+NSTEP-1)
          IK=IK+1
 300    CONTINUE
        WRITE(6,'(5X,A,10(I3,A))') '&  ',
     &    (ICH(I),',',I=NMAX+1,NIST)
        WRITE(6,'(5X,A)') '&           /'
C
        NMAX=180
        NSTEP=10
        NIST=187
        IK=18
        K0=1
        DO 350 II=1,NMAX,NSTEP
          IF(IK.EQ.18) THEN
            IF(II.NE.1) WRITE(6,'(5X,A)') '&           /'
            WRITE(6,'(5X,A,I3,A,I3,A)') ' DATA (IBBAR(K),K=',K0,',',
     &        MIN(NIST,K0-1+17*NSTEP),') /'
            K0=K0+17*NSTEP
            IK=1
          ENDIF
          WRITE(6,'(5X,A,10(I3,A))') '&  ',
     &      (IBAR(I),',',I=II,II+NSTEP-1)
          IK=IK+1
 350    CONTINUE
        WRITE(6,'(5X,A,10(I3,A))') '&  ',
     &    (IBAR(I),',',I=NMAX+1,NIST)
        WRITE(6,'(5X,A)') '&           /'
C
        NMAX=180
        NSTEP=10
        NIST=187
        IK=18
        K0=1
        DO 400 II=1,NMAX,NSTEP
          IF(IK.EQ.18) THEN
            IF(II.NE.1) WRITE(6,'(5X,A)') '&           /'
            WRITE(6,'(5X,A,I3,A,I3,A)') ' DATA (KB1(K),K=',K0,',',
     &        MIN(NIST,K0-1+17*NSTEP),') /'
            K0=K0+17*NSTEP
            IK=1
          ENDIF
          WRITE(6,'(5X,A,10(I4,A))') '&  ',
     &      (K1(I),',',I=II,II+NSTEP-1)
          IK=IK+1
 400    CONTINUE
        WRITE(6,'(5X,A,10(I4,A))') '&  ',
     &    (K1(I),',',I=NMAX+1,NIST)
        WRITE(6,'(5X,A)') '&           /'
C
        NMAX=180
        NSTEP=10
        NIST=187
        IK=18
        K0=1
        DO 450 II=1,NMAX,NSTEP
          IF(IK.EQ.18) THEN
            IF(II.NE.1) WRITE(6,'(5X,A)') '&           /'
            WRITE(6,'(5X,A,I3,A,I3,A)') ' DATA (KB2(K),K=',K0,',',
     &        MIN(NIST,K0-1+17*NSTEP),') /'
            K0=K0+17*NSTEP
            IK=1
          ENDIF
          WRITE(6,'(5X,A,10(I4,A))') '&  ',
     &      (K2(I),',',I=II,II+NSTEP-1)
          IK=IK+1
 450    CONTINUE
        WRITE(6,'(5X,A,10(I4,A))') '&  ',
     &    (K2(I),',',I=NMAX+1,NIST)
        WRITE(6,'(5X,A)') '&           /'
C
        NMAX=550
        NSTEP=5
        IK=18
        K0=1
        DO 500 II=1,NMAX,5
          IF(IK.EQ.18) THEN
            IF(II.NE.1) WRITE(6,'(5X,A)') '&           /'
            WRITE(6,'(5X,A,I3,A,I3,A)') ' DATA (ZBNAM(K),K=',K0,',',
     &        MIN(NMAX,K0-1+17*NSTEP),') /'
            K0=K0+17*NSTEP
            IK=1
          ENDIF
          WRITE(6,'(5X,16A)') '&  ',('''',ZKNAM(I),''',',I=II,II+4)
          IK=IK+1
 500    CONTINUE
        NSTEP=10
        IK=18
        K0=1
        DO 550 II=1,NMAX,NSTEP
          IF(IK.EQ.18) THEN
            WRITE(6,'(5X,A)') '&           /'
            WRITE(6,'(5X,A,I3,A,I3,A)') ' DATA (NBK1(K),K=',K0,',',
     &        MIN(NMAX,K0-1+17*NSTEP),') /'
            K0=K0+17*NSTEP
            IK=1
          ENDIF
          WRITE(6,'(5X,A,10(I4,A))') '&  ',(NZK(I,1),',',I=II,II+9)
          IK=IK+1
 550    CONTINUE
        IK=18
        K0=1
        DO 600 II=1,NMAX,NSTEP
          IF(IK.EQ.18) THEN
            WRITE(6,'(5X,A)') '&           /'
            WRITE(6,'(5X,A,I3,A,I3,A)') ' DATA (NBK2(K),K=',K0,',',
     &        MIN(NMAX,K0-1+17*NSTEP),') /'
            K0=K0+17*NSTEP
            IK=1
          ENDIF
          WRITE(6,'(5X,A,10(I4,A))') '&  ',(NZK(I,2),',',I=II,II+9)
          IK=IK+1
 600    CONTINUE
        IK=18
        K0=1
        DO 650 II=1,NMAX,NSTEP
          IF(IK.EQ.18) THEN
            WRITE(6,'(5X,A)') '&           /'
            WRITE(6,'(5X,A,I3,A,I3,A)') ' DATA (NBK3(K),K=',K0,',',
     &        MIN(NMAX,K0-1+17*NSTEP),') /'
            K0=K0+17*NSTEP
            IK=1
          ENDIF
          WRITE(6,'(5X,A,10(I4,A))') '&  ',(NZK(I,3),',',I=II,II+9)
          IK=IK+1
 650    CONTINUE
        NSTEP=5
        IK=18
        K0=1
        DO 700 II=1,NMAX,NSTEP
          IF(IK.EQ.18) THEN
            WRITE(6,'(5X,A)') '&           /'
            WRITE(6,'(5X,A,I3,A,I3,A)') ' DATA (BT(K),K=',K0,',',
     &        MIN(NMAX,K0-1+17*NSTEP),') /'
            K0=K0+17*NSTEP
            IK=1
          ENDIF
          WRITE(6,'(5X,A,10(E10.4,A))') '&  ',(WT(I),',',I=II,II+4)
          IK=IK+1
 700    CONTINUE
        WRITE(6,'(5X,A)') '&        /'
      ELSE
        WRITE(6,'(1X,A,I5)') 'PRIBLO:WARNING:UNSUPPORTED IMODE',IMODE
      ENDIF
      END
