#!/bin/bash
# S.Chekanov , v3
# this script is necessary for running
# under cygwin 1.5
# it cretaes single file from verious piaces .. 
# 
MYDIR=`pwd`
MAINFILE="runmc_pythia5.f"
args=$#           # Number of args passed.
LEVEL=$1


if [ $args == 0  ]
then
   echo " You did not specify what to do!"
   echo "--> Type \" split.sh  1 \" to split file $MAINFILE" 
   echo "--> Type \" split.sh  2 \" to combine all files into  $MAINFILE"
   exit 0;
fi


cd src; 


############################# do split ########################
if [ $LEVEL -eq "1" ]
then 
 if [ ! -f "$MAINFILE" ]
   then
   echo "nothing to do - all files splitted" 
   cd $MYDIR
   exit 0; 
 else 
   rm -f *.o
   $RUNMC/main/mcarlo/util/fsplit-5.5/fsplit $MAINFILE
   rm -f $MAINFILE 
   cd $MYDIR
 fi
exit 0;
fi

############################# do unsplit ########################
if [ $LEVEL -eq "2" ]
then
 if [ ! -f "$MAINFILE" ]
   then
   cat *.f  > main.tmp 
   rm -f *.o
   rm -f *.f
   mv -f main.tmp $MAINFILE 
   echo "file src/$MAINFILE created!" 
   cd $MYDIR
   exit 0;
 else
   echo "nothing to do - there is only one file src/$MAINFILE"
   cd $MYDIR
   exit 0;
  fi
exit 0;
fi




 
