/* This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


package com.actions;

import java.awt.AWTEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.util.StringTokenizer;
import java.util.Vector;

import com.jpe.jpe;



  public class tabAction implements ActionListener
	{
		jpe win;

		public tabAction(jpe win)
		{
			super();
			this.win = win;

		}


		public void actionPerformed(ActionEvent evt)
		{
			int start    = win.getSelectionStartLine();
			int end      = win.getSelectionEndLine();
			int selstart = win.getSelectionStart();
			int selend   = win.getSelectionEnd();

			if(start == end)
			{
				win.insertString("\t", selstart);
			}
			else
			{

				String s = win.getSelectedText();

				win.setSelectedText(splitOnToken(s.trim(), "\n"));
				win.Select(selstart + 1, selend + end - start + 1);
			}


		}


		public static String splitOnToken(String s, String token)
		{

		 StringBuffer sb = new StringBuffer();

		 StringTokenizer st = new StringTokenizer(s, token, false);

		 while(st.hasMoreTokens())
		 {
			 String r = st.nextToken();

			 sb.append("\t" + r + "\n");

		 }

     // remove the last \n
		 sb.delete(sb.length() - 1, sb.length());

      return sb.toString();
	  }




	}





