package JRunMC.web;

import JRunMC.ui.*;


import java.net.*;
import java.io.*;

public class copyRMC{

  static final int BLOCK_SIZE = 65500; // bytes
  static byte[] buf = new byte[BLOCK_SIZE];
  static final int SLEEP_UNIT = 333;   // msec
  static final String TMP_DIR = SetEnv.RUNDIR+"/"+SetEnv.WEBFILES;


  public static void getfile( String RMCfile) {

        String urlstring = "http://hepforge.cedar.ac.uk/runmc"+"/"+RMCfile;
        File here = new File(".");
        File localcopy = new File(urlstring);


    try {
     //   String urlstring = "http://hepforge.cedar.ac.uk/runmc"+"/"+RMCfile;
     //  File here = new File(".");
    //    File localcopy = new File(urlstring);

        if (!localcopy.exists()) {
          URL url = new URL(urlstring);
          String filename = urlstring.substring(urlstring.lastIndexOf('/') + 1); // jar name
          File root = new File(here.getAbsolutePath()); // is not it something?
          while (root.getParent() != null && root.getParent() != root.getCanonicalPath()) {
            root = new File(root.getParent()); // that's the way to find the root
          }
          File tmpdir = new File(root, TMP_DIR);

          if (!tmpdir.exists()) tmpdir.mkdirs();

          localcopy = new File(tmpdir, filename); // local copy of the jar
          InputStream is = new BufferedInputStream(url.openStream());
          OutputStream os = new BufferedOutputStream(new FileOutputStream(localcopy));
          pipe(is, os, true);
          os.close();
          is.close();
        } 

	
    } catch (Exception e) {
      RMCwebLoader.showMess.settext("Error in connection with HEPforge");  
      System.err.println(e);
    }
  }




  static void pipe(InputStream in, OutputStream out, boolean isBlocking) throws IOException {
    int nread;
    int navailable;
    int total = 0;
    synchronized (in) {
      while((navailable = isBlocking ? Integer.MAX_VALUE : in.available()) > 0 &&
            (nread = in.read(buf, 0, Math.min(buf.length, navailable))) >= 0) {
        out.write(buf, 0, nread);
        total += nread;
      }
    }
    out.flush();
  }
}
