** read steering card for HERWIG/PYTHIA/LEPTO 
** RAPGAP and CASCADE use personal version of it
** S.C. 
      Subroutine runmc_steer(inputsteer) 

      Implicit None
      include "../inc/runmc_steer.inc" 
      LOGICAL  EX


      INQUIRE(FILE=inputsteer, EXIST=EX)
      IF (EX) THEN
        WRITE(6,*) ''
        WRITE(6,*) 'RUNMC: File= ',inputsteer, ' exits!'
        WRITE(6,*) 'RUNMC: will try to overwrite some parameters:'  
      open(UNIT=2,FILE=inputsteer,STATUS='OLD',FORM='FORMATTED')
      ELSE
        WRITE(6,*) ''
        WRITE(6,*) 'RUNMC: File= ',inputsteer, ' does not exits!' 
        WRITE(6,*) 'RUNMC: use the default parameters from GUI'
        WRITE(6,*) ''
      GOTO 100  
      ENDIF
 
*** 

        
      nloop = 0
   20 Read(2,101,END=100) TXT
      If(TXT(1:1).EQ.'*') then
C         WRITE(6,*) '*',TXT
         GOTO 20
      Endif

 
      If(TXT(1:4).EQ.'END$') goto 90


      inte = 0 

      do j=2,72
      i=j-1

* mark integer values: general definitions  
      if(TXT(i:i).EQ."'".and.
     &(TXT(J:J).EQ.'H'.OR.TXT(J:J).EQ.'I'.OR.TXT(J:J).EQ.'J'.
     &OR.TXT(J:J).EQ.'K'.OR.TXT(J:J).EQ.'L'.OR.TXT(J:J).EQ.'M'.
     &OR.TXT(J:J).EQ.'N')) then
      inte = 1
      endif 
** end reading line 
      enddo 



       nloop = nloop + 1
       Ival(nloop) = -9999
       Rval(nloop) = -9999.
       if(inte.eq.1) then
      read(txt,*) char,i1,i2,i3,char2
c      write(6,*) ' output Integer :',char,i1,i2,i3 
       Ival(nloop) = i3
      else
      read(txt,*) char,i1,i2,r3,char2
c     write(6,*) ' output real    :',char,i1,i2,r3
      Rval(nloop) = r3
      endif
      Ld(nloop) = i1
      Le(nloop) = i2
      parax(nloop) = char


       if(inte.eq.1) write(6,*) 'RUNMC reads steering value: ',
     +  nloop,"  ",parax(nloop),"  ",  Ival(nloop)
       if(inte.eq.0) write(6,*) 'RUNMC reads steering value: ',
     +  nloop,"  ", parax(nloop),"  ", Rval(nloop)



      goto 20

   90 Continue

      
  100 Return

 
      close(UNIT=2)

 101  Format(A72)
      write(6,*) " "
   
      continue  
      End
