// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.
// define your enviromental variable
package com.jpe;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.lang.*;



     public class LogMessage extends JScrollPane implements Constants { 

     private static JTextArea jT1;
     
      
     public LogMessage() {
    
     // comments
         jT1 = new JTextArea();
         jT1.setLineWrap(true);
         jT1.setFont(SetEnv.FontBold);
         jT1.setEditable(false);
         jT1.setCaretPosition(0);
         jT1.setWrapStyleWord(true);
         jT1.setCaretColor(Color.red);
      //   jT1.getCaret().setBlinkRate(300);
         this.getViewport().add(jT1);
 
     } 



 public void ClearText()
 {

   jT1.setText("");

}


     public void SetText(String fileName ) {

     try {
      File file = new File(fileName);
      int size = (int)file.length();
      // Set to zero a counter for counting the number of
      // characters that have been read from the file.
      int chars_read = 0;
      // Create an input reader based on the file, so we can read its data.
      // FileReader handles international character encoding conversions.
      FileReader in = new FileReader(file);
      // Create a character array of the size
      char[] data = new char[size];
      // Read all available characters into the buffer.
      while(in.ready()) {
        // Increment the count for each character read,
        // and accumulate them in the data buffer.
        chars_read += in.read(data, chars_read, size - chars_read);
      }
      in.close();

      // Create a temporary string containing the data,
      // and set the string into the JTextArea.
      jT1.setText(new String(data, 0, chars_read));
    }
    catch (IOException e)
    {
      System.out.println("Error opening "+fileName);
    }


     }
    
    
    
     
     
   }
